package com.idea.customerManagement.controller;

import com.github.pagehelper.PageInfo;
import com.idea.customerManagement.dto.ContractManageDto;
import com.idea.customerManagement.dto.CustomerManagementDto;
import com.idea.customerManagement.model.ContractManage;
import com.idea.customerManagement.service.ContractManageService;
import com.rockstar.common.base.BaseController;
import com.rockstar.common.domain.AjaxResult;
import com.rockstar.frame.model.extend.DateTrans;
import com.rockstar.frame.model.extend.TableSplitResult;
import com.rockstar.frame.model.extend.Tablepar;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
@RequestMapping(value = "ContractManageController")
@Api(tags = "合同管理")
public class ContractManageController extends BaseController {

    @Autowired
    private ContractManageService modelService;






    /**
     * 分页
     * @param tablepar
     * @param model
     * @param dt
     * @return
     */
    @PostMapping(value = "list",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object list(Tablepar tablepar, ContractManageDto model, DateTrans dt){
        PageInfo<ContractManageDto> page= modelService.listByModel(tablepar,model,dt);
        TableSplitResult<ContractManageDto> result = new TableSplitResult<ContractManageDto>(page.getPageNum(), page.getTotal(), page.getList());
        return  result;
    }

    /**
     * 编辑合同
     * @param record
     * @return
     */
    @PostMapping(value = "edit",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult edit(ContractManage record){
        int result = modelService.edit(record);
        return result(result);
    }

    @PostMapping(value = "getById",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object getById(String id) {
        return modelService.getById(id);
    }


    /**
     * 获取合同对应的银行账号
     * @param contractId
     * @return
     */
    @PostMapping(value = "getBankList",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object getBankList(String contractId){
        return modelService.getBankList(contractId);
    }


}
