package com.idea.customerManagement.model;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

@Data
public class ContractManage implements Serializable {
    private String id;

    private String recordNumber;

    private String contractNumber;

    private String seller;

    private String houseId;

    private String houseName;

    private Double actualBuildArea;

    private Double actualInternalArea;

    private Double actualShareArea;

    private String institution;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date signingDate;

    private BigDecimal housePrice;

    private BigDecimal totalPrice;

    private Double buyerProportion;

    private BigDecimal buyerMoney;

    private String buyerName;

    private Integer paymentMethod;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date deadline;

    private BigDecimal maintenanceFunds;

    private BigDecimal maintenanceTotalPrice;

    private Integer contractStatus;

    private String customerManagementId;

    private BigDecimal subscriptionFunds;

    private String createdId;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date createdAt;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date updatedAt;

    private String updatedId;

    private String remark;

    private String contractOriginal;

    private String contractOther;

    private String downPaymentsProportion;

    private Integer collectionStatus;

    private Integer fundCollectionStatus;

    private static final long serialVersionUID = 1L;

    private String bankName;

    private String bankNumber;


}