package com.idea.invoice.util;

public class InvoiceConstant {

    // 0待开票 1已开票 2已发票作废 3待坏账红冲 4已坏账红冲
    public static final String INVOICE_STATUS_WAIT = "0";
    public static final String INVOICE_STATUS_FINISH = "1";
    public static final String INVOICE_STATUS_ERROR = "2";
    public static final String INVOICE_STATUS_WAIT_BAD_DEBT = "3";
    public static final String INVOICE_STATUS_BAD_DEBT = "4";

    /**
     * NC 单据编码
     */
    // 收款单
    public static final String INVOICE_BUSINESS_F2_Cxx_06 = "F2-Cxx-06";

    // 转账单
    public static final String INVOICE_BUSINESS_F2_Cxx_07 = "F2-Cxx-07";

    // 换票单
    public static final String INVOICE_BUSINESS_F2_Cxx_08 = "F2-Cxx-08";

    // 退款单
    public static final String INVOICE_BUSINESS_F3_Cxx_06 = "F3-Cxx-06";

    // 划拨单（水电费、维修）
    public static final String INVOICE_BUSINESS_F2_Cxx_09 = "F2-Cxx-09";

    // 收入结转单
    public static final String INVOICE_BUSINESS_F0_Cxx_05 = "F0-Cxx-05";

    /**
     * 业态
     */
    // 住宅
    public static final String INVOICE_BUSINESS_FORMAT_001 = "001";
    // 车位
    public static final String INVOICE_BUSINESS_FORMAT_002 = "002";
    // 储藏室
    public static final String INVOICE_BUSINESS_FORMAT_003 = "003";
    // 商业
    public static final String INVOICE_BUSINESS_FORMAT_004 = "004";
    // 酒店
    public static final String INVOICE_BUSINESS_FORMAT_005 = "005";
    // 配套
    public static final String INVOICE_BUSINESS_FORMAT_006 = "006";

    /**
     * 物料
     */
    // 东璟家园C
    public static final String INVOICE_MATERIAL_djjy = "djjy";

    // 共有产权房惠景家园
    public static final String INVOICE_MATERIAL_gycqrjjy = "gycqrjjy";
    // 惠景家园
    public static final String INVOICE_MATERIAL_hjjy = "hjjy";
    // 黄石家园
    public static final String INVOICE_MATERIAL_hsjy = "hsjy";
    // 毛湾家园B
    public static final String INVOICE_MATERIAL_mwjyB = "mwjyB";
    // 瑞扬家园
    public static final String INVOICE_MATERIAL_ryjy = "ryjy";

    /**
     * 收款类型
     */
    // 定金
    public static final String INVOICE_PAYMENT_TYPE_AJ001 = "AJ001";

    // 首期
    public static final String INVOICE_PAYMENT_TYPE_AJ002 = "AJ002";

    // 楼款
    public static final String INVOICE_PAYMENT_TYPE_AJ003 = "AJ003";

    // 补差款
    public static final String INVOICE_PAYMENT_TYPE_AJ004 = "AJ004";

    // 银行按揭
    public static final String INVOICE_PAYMENT_TYPE_AJ006 = "AJ006";

    // 公积金
    public static final String INVOICE_PAYMENT_TYPE_AJ007 = "AJ007";

    // 维修基金
    public static final String INVOICE_PAYMENT_TYPE_AJ015 = "AJ015";

    // 滞纳金
    public static final String INVOICE_PAYMENT_TYPE_AJ022 = "AJ022";

    // 挞定款
    public static final String INVOICE_PAYMENT_TYPE_AJ024 = "AJ024";

    // 住宅诚意金
    public static final String INVOICE_PAYMENT_TYPE_AJ026 = "AJ026";

    // 车位诚意金
    public static final String INVOICE_PAYMENT_TYPE_AJ027 = "AJ027";

    /**
     * 票据类型
     */
    // 无票据
    public static final String INVOICE_RECEIPT_TYPE_1 = "1";

    // 发票
    public static final String INVOICE_RECEIPT_TYPE_2 = "2";

    // 收据
    public static final String INVOICE_RECEIPT_TYPE_3 = "3";

    // 增值税（专）
    public static final String INVOICE_RECEIPT_TYPE_4 = "4";

    // 增值税（普）
    public static final String INVOICE_RECEIPT_TYPE_5 = "5";

    /**
     * 项目档案
     */
    public static final String INVOICE_PROJECT_CODE_mwjyAdk = "mwjyAdk";

    /**
     * 结算方式
     */
    // pos机
    public static final String INVOICE_PAYMENT_METHOD_11 = "11";

    // 电汇
    public static final String INVOICE_PAYMENT_METHOD_4 = "4";

    // 现金
    public static final String INVOICE_PAYMENT_METHOD_0 = "0";

    // 工抵房
    public static final String INVOICE_PAYMENT_METHOD_12 = "12";



}
