package com.idea.my.controller;

import com.github.pagehelper.PageInfo;
import com.idea.my.model.MyMenu;
import com.idea.my.service.MyMenuService;
import com.rockstar.common.base.BaseController;
import com.rockstar.common.domain.AjaxResult;
import com.rockstar.frame.model.extend.DateTrans;
import com.rockstar.frame.model.extend.TableSplitResult;
import com.rockstar.frame.model.extend.Tablepar;
import com.rockstar.frame.service.FramePermissionService;
import com.rockstar.util.SnowflakeIdWorker;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.Date;

/**
 * Created by xuyq on 2019/7/2.
 */
@Controller
@RequestMapping(value = "MyMenuController")
@Api(value = "我的快捷菜单")
public class MyMenuController extends BaseController {

    @Autowired
    private MyMenuService modelService;

    @Autowired
    private FramePermissionService framePermissionService;


    @PostMapping(value = "list",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object list(Tablepar tablepar, MyMenu model, DateTrans dt){
        PageInfo<MyMenu> page = modelService.list(tablepar, model, dt);
        TableSplitResult<MyMenu> result=new TableSplitResult<MyMenu>(page.getPageNum(), page.getTotal(), page.getList());
        return  result;
    }

    @PostMapping(value = "listAll",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object listAll(MyMenu model, DateTrans dt){
        return modelService.listAll(model,dt);
    }

    @PostMapping(value = "getMyMenu",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object getMyMenu(MyMenu model){
        return modelService.getMyMenu(model);
    }

    @PostMapping(value = "listPermissionAll",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object listPermissionAll(MyMenu model){
        return  this.framePermissionService.getMenuTree();
    }


    @PostMapping(value = "add",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult add(MyMenu model){
        String auditId = SnowflakeIdWorker.getUUID();
        model.setCreatedAt(new Date());
        model.setId(auditId);
        int result = modelService.insert(model);
        AjaxResult ajaxResult = result(result);
        ajaxResult.put("auditId", auditId);
        return ajaxResult;

    }

    @PostMapping(value = "remove/{id}",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult remove(@PathVariable("id") String id){
        int result = modelService.deleteByPrimaryKey(id);
        return result(result);
    }

    @PostMapping(value = "edit",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult editSave(MyMenu model){
        model.setUpdatedAt(new Date());
        int result = modelService.updateByPrimaryKeySelective(model);
        return result(result);
    }

    @PostMapping(value = "getById",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public MyMenu getbyId(String id)
    {
        return modelService.selectByPrimaryKey(id);
    }



    @PostMapping(value = "bizUserListAll",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object bizUserListAll(String mainId){
        return modelService.bizUserListAll(mainId);
    }
}
