package com.idea.paymentManagement.controller;

import com.github.pagehelper.PageInfo;
import com.idea.customerManagement.dto.ContractManageDto;
import com.idea.customerManagement.model.IntentionalDeposit;
import com.idea.paymentManagement.dto.PayLogDto;
import com.idea.paymentManagement.model.PayLog;
import com.idea.paymentManagement.service.PayLogService;
import com.rockstar.common.base.BaseController;
import com.rockstar.common.domain.AjaxResult;
import com.rockstar.frame.model.extend.DateTrans;
import com.rockstar.frame.model.extend.TableSplitResult;
import com.rockstar.frame.model.extend.Tablepar;
import com.rockstar.shiro.util.ShiroUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.util.Date;

@Controller
@RequestMapping(value = "PayLogController")
@Api(tags = "房款管理")
public class PayLogController extends BaseController {

    @Autowired
    private PayLogService modelService;


    @PostMapping(value = "list",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object list(Tablepar tablepar, ContractManageDto model, DateTrans dt){
        PageInfo<ContractManageDto> page= modelService.listByModel(tablepar,model,dt);
        TableSplitResult<ContractManageDto> result = new TableSplitResult<ContractManageDto>(page.getPageNum(), page.getTotal(), page.getList());
        return  result;
    }



    @ApiOperation(value = "收款信息列表")
    @PostMapping(value = "payListAll",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object listAll(PayLog model, DateTrans dt){
        return  modelService.payListAll(model,dt);
    }

    /**
     * 合同部分信息
     * @param contractId
     * @return
     */
    @PostMapping(value = "getContractPart",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object getContractPart(String contractId){
        return  modelService.getContractPart(contractId);
    }


    @ApiOperation(value = "删除")
    @PostMapping(value = "remove",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult remove(String id){
        int result = modelService.delete(id);
        return result(result);
    }


    @ApiOperation(value = "新增收款")
    @PostMapping(value = "add",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult add(PayLog record){

        int result = modelService.add(record,null);
        return result(result);
    }

    @PostMapping(value = "getByContractId",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object getByContractId(String contractId,Integer payType){
        PayLog result = modelService.getByContractId(contractId, payType);
        return result;
    }

    @PostMapping(value = "getById",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object getById(String id){
        PayLogDto result = modelService.getById(id);
        return result;
    }


    /**
     * 收款收据下载
     * @param id
     * @param response
     */
    @GetMapping(value = "downLoadReceipt",produces = {"application/json;charset=UTF-8"})
    public void downLoadReceipt(String id, HttpServletResponse response) {
        modelService.downLoadReceipt(id,response);
    }

    /**
     * 定金转首款 转房款
     * @param id
     * @param type
     * @return
     */
    @PostMapping(value = "convertType",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult convertType(String id,Integer type){
        int result = modelService.convertType(id, type);
        return result(result);
    }





}
