package com.idea.pro.config;

import com.github.xiaoymin.swaggerbootstrapui.annotations.EnableSwaggerBootstrapUI;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import springfox.documentation.builders.ApiInfoBuilder;
import springfox.documentation.builders.PathSelectors;
import springfox.documentation.builders.RequestHandlerSelectors;
import springfox.documentation.service.ApiInfo;
import springfox.documentation.spi.DocumentationType;
import springfox.documentation.spring.web.plugins.Docket;
import springfox.documentation.swagger2.annotations.EnableSwagger2;

/**
 * swagger在线文档配置<br>
 * 项目启动后可通过地址：http://host:ip/swagger-ui.html 查看在线文档
 *
 * @author
 * @version 2018-07-24
 */
@EnableSwaggerBootstrapUI
@Configuration
@EnableSwagger2
public class ProSwagger {

    @Bean
    public Docket demoDocket() {

        return new Docket(DocumentationType.SWAGGER_2)
                .groupName("demo")
                .apiInfo(apiInfo("Demo API","样例功能API"))
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.idea.demo.controller"))
                .paths(PathSelectors.any())
                .build();
    }

    @Bean
    public Docket proDocket() {

        return new Docket(DocumentationType.SWAGGER_2)
                .groupName("pro")
                .apiInfo(apiInfo("Project API","业务项目API"))
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.idea.pro.controller"))
                .paths(PathSelectors.any())
                .build();
    }

    private ApiInfo apiInfo(String title, String desc) {
        return new ApiInfoBuilder()
                .title(title)
                .description(desc)
                .termsOfServiceUrl("http://localhost:9001")
                .contact("pengyq")
                .version("1.0")
                .build();
    }
}
