package com.idea.saleManage.controller;

import com.github.pagehelper.PageInfo;

import com.idea.customerManagement.mapper.CustomerManagementMapper;
import com.idea.saleManage.model.CheckIn;
import com.idea.saleManage.model.CheckInMore;
import com.idea.saleManage.service.CheckInService;
import com.rockstar.common.base.BaseController;
import com.rockstar.common.domain.AjaxResult;
import com.rockstar.frame.model.FrameFile;
import com.rockstar.frame.model.extend.DateTrans;
import com.rockstar.frame.model.extend.TableSplitResult;
import com.rockstar.frame.model.extend.Tablepar;
import com.rockstar.shiro.util.ShiroUtils;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.Date;

/**
 * Created by zt on 2023
 */
@Controller
@RequestMapping(value = "CheckInController")
@Api(value="入住登记")
public class CheckInController extends BaseController {

    //主表
    @Autowired
    private CheckInService modelService;


    @PostMapping(value = "list",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object list(Tablepar tablepar, CheckInMore model, DateTrans dt){
        PageInfo<CheckInMore> page= modelService.list(tablepar,model,dt);
        TableSplitResult<CheckInMore> result=new TableSplitResult<CheckInMore>(page.getPageNum(), page.getTotal(), page.getList());
        return  result;
    }

    @PostMapping(value = "listAll",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object listAll(CheckInMore model, DateTrans dt){
        return  modelService.listAll(model,dt);
    }

    @PostMapping(value = "add",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult add(CheckIn record){
        record=this.addInfo(record);
        int result = modelService.insert(record);
        return result(result);
    }

    @PostMapping(value = "remove/{id}",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult remove(@PathVariable("id") String id){
        int result = modelService.deleteByPrimaryKey(id);
        return result(result);
    }

    @PostMapping(value = "edit",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult editSave(CheckIn model,String customerManagementId){
        model=this.addInfo(model);
        int result = modelService.edit(model,customerManagementId);
        return result(result);
    }

    public CheckIn addInfo(CheckIn model){
        if ("null".equals(model.getStatus())){
            model.setStatus(null);
        }
        model.setOperateTime(new Date());
        model.setOperaterId(ShiroUtils.getUser().getId());
        return model;
    }

    @PostMapping(value = "getById",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public CheckIn getById(String id) {
        return modelService.selectByPrimaryKey(id);
    }


}
