package com.idea.saleManage.controller;

import com.github.pagehelper.PageInfo;

import com.idea.saleManage.model.CheckIn;
import com.idea.saleManage.model.PropertyRegistration;
import com.idea.saleManage.model.PropertyRegistrationMore;
import com.idea.saleManage.service.PropertyRegistrationService;
import com.rockstar.common.base.BaseController;
import com.rockstar.common.domain.AjaxResult;
import com.rockstar.frame.model.FrameFile;
import com.rockstar.frame.model.extend.DateTrans;
import com.rockstar.frame.model.extend.TableSplitResult;
import com.rockstar.frame.model.extend.Tablepar;
import com.rockstar.shiro.util.ShiroUtils;
import io.swagger.annotations.Api;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.Date;

/**
 * Created by zt on 2023
 */
@Controller
@RequestMapping(value = "PropertyRegistrationController")
@Api(value="产权登记")
public class PropertyRegistrationController extends BaseController {

    //主表
    @Autowired
    private PropertyRegistrationService modelService;


    @PostMapping(value = "list",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object list(Tablepar tablepar, PropertyRegistrationMore model, DateTrans dt){
        PageInfo<PropertyRegistrationMore> page= modelService.list(tablepar,model,dt);
        TableSplitResult<PropertyRegistrationMore> result=new TableSplitResult<PropertyRegistrationMore>(page.getPageNum(), page.getTotal(), page.getList());
        return  result;
    }

    @PostMapping(value = "listAll",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object listAll(PropertyRegistrationMore model, DateTrans dt){
        return  modelService.listAll(model,dt);
    }

    @PostMapping(value = "add",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult add(PropertyRegistration record){
        record=this.addInfo(record);

        int result = modelService.insert(record);
        return result(result);
    }

    @PostMapping(value = "remove/{id}",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult remove(@PathVariable("id") String id){

    int result = modelService.deleteByPrimaryKey(id);
        return result(result);
    }

    @PostMapping(value = "edit",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult editSave(PropertyRegistration model){
        model=this.addInfo(model);

        int result = modelService.updateByPrimaryKey(model);
        return result(result);
    }
    public PropertyRegistration addInfo(PropertyRegistration model){
        if ("null".equals(model.getStatus())){
            model.setStatus(null);
        }
        model.setOperateTime(new Date());
        model.setOperaterId(ShiroUtils.getUser().getId());
        return model;
    }
    @PostMapping(value = "getById",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public PropertyRegistration getById(String id) {
        return modelService.selectByPrimaryKey(id);
    }


}
