package com.idea.search.pojo;

import org.springframework.data.elasticsearch.annotations.Document;
import org.springframework.data.elasticsearch.annotations.Field;
import org.springframework.data.elasticsearch.annotations.FieldType;

import javax.persistence.Id;

//操作日志数据索引库
@Document(indexName = "op_log_record", type = "docs")
public class OpLogRecord {

    //日常表id
    @Id
    @Field(index = true,store = true,type = FieldType.Keyword)
    private String id;

    @Field(index =true,store = true,type = FieldType.Keyword)
    private String title;
    @Field(index =true,store = true,type = FieldType.Keyword)
    private String method;
    @Field(index =true,store = true,type = FieldType.Keyword)
    private String operName;
    @Field(index =true,store = true,type = FieldType.Keyword)
    private String operUrl;
    @Field(index =true,store = true,type = FieldType.Keyword)
    private String operParam;
    @Field(index =true,store = true,type = FieldType.Keyword)
    private String errorMsg;
    @Field(index =true,store = true,type = FieldType.Keyword)
    private String operAt;;

    // field建议都是private String格式
    // 如果某个field是需要统计，则FieldType替换成Double
    // @Field(index =true,store = true,type = FieldType.Double)//支持 max min svg sum


    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getMethod() {
        return method;
    }

    public void setMethod(String method) {
        this.method = method;
    }

    public String getOperName() {
        return operName;
    }

    public void setOperName(String operName) {
        this.operName = operName;
    }

    public String getOperUrl() {
        return operUrl;
    }

    public void setOperUrl(String operUrl) {
        this.operUrl = operUrl;
    }

    public String getOperParam() {
        return operParam;
    }

    public void setOperParam(String operParam) {
        this.operParam = operParam;
    }

    public String getErrorMsg() {
        return errorMsg;
    }

    public void setErrorMsg(String errorMsg) {
        this.errorMsg = errorMsg;
    }

    public String getOperAt() {
        return operAt;
    }

    public void setOperAt(String operAt) {
        this.operAt = operAt;
    }
}
